#!/usr/bin/perl -w

###########################################################################
#                                                                         #
# AutoResponse V0.3 by geeAge (http://www.greyArea.de)                    #
#                                                                         #
# this script prints an automatic response dependent on your current nick #
# and/or it plays a wave whenever your nickname(or a defined part of it)  #
# appears                                                                 #
# script will play a sound on the first query of another user             #
# also you will notify if a selected user send a message and you can      #
# send him automaticly a message                                          #
# like in mIRC (a windows irc client), you can send a message in all your #
# channels at the same time                                               #
#                                                                         #
# commands:                                                               #
# /response [on|off]          - turns autoresponse on/off                 #
# /sound [on|off]             - turns playing of sounds on/off            #
# /amsg text                  - sends 'text' to all your channles         #
# /returnof nick #chan [text] - notify you if 'nick' (which must be in    #
#                               '#chan') writes a msg in one of your      #
#                               channels  (and can send 'nick' a 'text')  #
# /reset                      - restes the sending/playing of responses   #
#                               and sounds                                #
# /help                       - shows a short list/help of commands       #
#                                                                         #
# please report bugs to geeage@greyarea.de                                #
#                                                                         #
# EDIT the following CONFIG section!!:                                    #   
###########################################################################


#######################################
#                                     #
# CONFIG start                        #
#                                     #
#######################################

#your play cmd e.g. /usr/bin/play
my $play= "/usr/bin/play";
#wav to play if nick detect or query e.g.  /home/geeage/.xchat/scripts/tock.wav
my $wavNormal = "tock.wav";
#wav to play for first query e.g.  /home/geeage/.xchat/scripts/yahoo.wav
my $wavFirstQuery = "yahoo.wav";
#wav to play for return of a user
my $wavReturn = "yahoo.wav";


#for autoresponse
#insert your nicks and the wanted FIRST responses for them
#use (at this point) just small letters in your nicks (in IRC you can use both)
#if you use " ' $ & @ # % in your response add \ before like \"
#IRC allows only to use |[]_^\- in your nick!
my %res_Hash =(
"gee|shower" => 'IEEEK! don\'t look! *g*',
"gee|work" => 'sorry, I\'m busy -> query if urgent',
);

#SECOND response text (send after first response)
my $secResponse="sorry, still busy...";
#number of responses to send (onetime 'main'-response, othertimes sec. response)
my $numOfAnswers=2;
#show that a response was sent? 1=yes, 0=no
my $showSendOfResponse=1;


#text before/after your response from hash
my $textBefore="++[autoresponse]: ";
my $textAfter="!++";
#textcolor ->\0033=blue,\0034=red,\0035=green
my $color="\0034";
#$resNick='1' -> in the response appears the nick of the person
#which was activating it
#the nick is placed in the response before $text_after, if $resnick='0' not
my $resNick='1';


#if one of these words/nicks etc. appears, the script doesn't print the response 
#use only small letters and change all non-alphanumerical letters like ?!|-+.?! in \\? or \\! or \\| \\.etc. 
#convert chars @\"'$ in \\\@ \\\\ \\\" \\\' \\\$
#if you want more than one word use | between them: $ignores="word1|word2|word3"; (you can use regular expr.)
#!DONT LET THEM FREE!!! -> use minimal $ingores="x9x8x7x6x5x4x3x2x1x0x\\!\\?";
#you can also use hostmasks e.g. gee@D354657.dip.t-dailin.net but you must
#convert it into: gee\\\@.*dip\\.t\\-dailin\\.net
my $ignores="user\\\@141\\.58\\.9\\.54|x9x8x7x6x5x4x3x2x1x0x\\!\\?";


#sound is playing whenever this nick (or part of it) appears
#use only small letters and change all non-alphanumerical letters like ?!|$-+.?! in \\? or \\! or \\| etc. 
#if you want more words use | between: $alwaysResNicks="nick1|nick2|nick3"; (you can use regular expr.)
#!DONT LET THEM FREE!!! -> use minimal $alwaysResNicks="x9x8x7x6x5x4x3x2x1x0x\\!\\?";
#if you dont want found your nick(s) inside of other words try this:
#$alwaysResNicks="(^|\\ )(myfirstnick|mysecondnick)(\\ |\\?|\$|\\!|\\.)|x9x8x7x6x5x4x3x2x1x0x\\!\\?"
my $alwaysResNicks="(^|\\ )(nick1|nick2)(\\ |\\?|\$|\\!|\\.)|x9x8x7x6x5x4x3x2x1x0x\\!\\?";
		 
#logging 1=yes, 0=no
my $logging=0;
#logfileanme and path e.g.  /home/geeage/.xchat/scripts/AutoResponse.log
my $logfile="AutoResponse.log";

######################################
#                                    #
# CONFIG end                         #
#                                    #
######################################

#program
IRC::register("geeAge's autoresponse script", "0.3", "", "");
IRC::print("\0035++Loading geeAge's autoresponse script V0.3::\003 \n");
IRC::print("\0033++USE: /response [on/off]\003\n");
IRC::print("\0033++turns autoresponse on/off\003\n");
IRC::print("\0033++USE: /sound [on/off]\n");
IRC::print("\0033++turns sound and autoresponse on/off\003\n");
IRC::print("\0033++USE: /amsg text\n");
IRC::print("\0033++sends 'text' to all joined channels\003\n");
IRC::print("\0033++USE: /returnof nick #channel [optional message to user if he returns]\n");
IRC::print("\0033++plays a sound if user write something [and can send him a message]\003\n");
IRC::print("\0033++USE: /reset\n");
IRC::print("\0033++reset the sending of responses and first query-sound\003\n");
IRC::print("\0033++USE: /help\n");
IRC::print("\0033++print this commands\n");
IRC::print("\0035++response and sounds are turned on\003 \n");

#logging
if($logging)
  {
    IRC::print("\0035++Logging in file $logfile\003\n");
    logThis("\n+++++++++++++++++++++++++++++++++\nNEW START of script\n++++++++++++++++++\n");
	}

#handler
IRC::add_message_handler("PRIVMSG", "privmsg_handler_autoresponseV03");
IRC::add_command_handler("sound", "ps_command_handler");
IRC::add_command_handler("response", "ar_command_handler");
IRC::add_command_handler("returnof", "ro_command_handler");
IRC::add_command_handler("ro", "ro_command_handler");
IRC::add_command_handler("reset", "reset_command_handler");
IRC::add_command_handler("amsg", "amsg_command_handler");
IRC::add_command_handler("help", "help_command_handler");

#global vars
my $response=1;
my $sound = 1;
my $insertNick='';
my $myNickOld=IRC::get_info(1);
my %hm_HashRes=();
my %hm_HashQuery=();
my %hm_hashReturn=();


#subs
sub privmsg_handler_autoresponseV03 
	{
		if(($response)||($sound))
			{
				#get irc infos
				my $myNick = IRC::get_info(1);
				my $actLine = shift(@_);
				
				#parse act. msg
				$actLine =~ m/\:(.*?)\!(.*?)\sPRIVMSG\s(.*?)\s\:(.*)?/;
				my $msgNick = $1;
				my $hmSender = $2;
				my $msgType = $3;
				my $msgLine = $4;
				
				my $query = 1;
				if($3 =~ m/\#/)
					{
						$query=0;
					}
				
				#conv. to lc for compares
				my $myNickLc = $myNick;
				$myNickLc =~ tr/A-Z/a-z/;
				my $msgLineLc=$msgLine;
				$msgLineLc =~ tr/A-Z/a-z/;
				my $msgSenderLc=$msgNick.$hmSender;
				$msgSenderLc =~ tr/A-Z/a-z/;
				
				#DEBUG# IRC::print "$actLine\n";
				#DEBUG# IRC::print "\0034msgNick:$msgNick, msgtype:$msgType, msgLine:$msgLineLc, Query? $query, ($myNick,$myNickLc)\003 \n";
				
				#reset if you change your nick
				if($myNick ne $myNickOld)
					{
						$myNickOld=$myNick;
						#del hashs
						%hm_HashRes=();
						%hm_HashQuery=();
						
						if($logging){logThis("RESET: reset by nickchange");}
					}
				
				if($query)
					{
						if(exists($hm_HashQuery{$hmSender}))
							{
								$hm_HashQuery{$hmSender}+=1;
							}
						else
							{
								if($sound){system("$play $wavFirstQuery \&");}
								$hm_HashQuery{$hmSender}=1;
								
								if($logging){ logThis("QUERY: 1st query from $msgNick($hmSender)");}
							}
					}
				
				#search for returns...
				if(exists($hm_HashReturn{$hmSender}))
					{
						if($sound){system("$play $wavReturn \&");}
						IRC::print("\0034+++$msgNick has return!+++\n");
						
						if($logging){logThis("RET: return of $msgNick($hmSender)");}
						
						my $returnMsg=$hm_HashReturn{$hmSender};
						if($returnMsg)
							{
								my $resMsg="NOTICE ".$msgNick." :".$color.$textBefore.$response.$insertNick.$textAfter."\n";
								IRC::send_raw("NOTICE $msgNick :\0034+++[autosend] $returnMsg+++\003\n");
								IRC::print("\0034+++script has sent \"$returnMsg\" to $msgNick+++\003\n");
								
								if($logging){ logThis("RET: send msg to returned user $msgNick");}
							}
						delete $hm_HashReturn{$hmSender};
					}
				
				
				
				#compares for sounds and responses
				if(($query)|| (index($msgLineLc,$myNickLc)!=-1) || ($msgLineLc=~ m/$alwaysResNicks/) )
					{
						if($sound){system("$play $wavNormal \&");}
						if($logging){ logThis("play normalWav (query=$query)");}
						
						if(($response)&&(exists($res_Hash{$myNickLc}))&&!($msgSenderLc=~ m/$ignores/i))
							{
								my $response='';
								my $doResponse=1;
								my $numOfRes=0;
								
								#send already a res?
								if(exists($hm_HashRes{$hmSender}))
									{
										$numOfRes=$hm_HashRes{$hmSender};
										$hm_HashRes{$hmSender}=$numOfRes+1;
										
										if($logging){ logThis("RES: $numOfRes. res or query($query) found from $msgNick");}
										
										if($numOfRes<$numOfAnswers)
											{
												$response=$secResponse;
												
												if($logging){ logThis("RES: 2. RESPONSE selected for $msgNick($hmSender)");}
											}
										else
											{
												#no response
												$doResponse=0;
											}
									}
								else
									{
										$hm_HashRes{$hmSender}=1;
										$response=$res_Hash{$myNickLc};
										
										if($logging){ logThis("RES: 1. RESPONSE selected for $msgNick($hmSender)");}
									}
								
								if($doResponse)
									{
										if($resNick eq '1')
											{
												$insertNick=', '.$msgNick.' ';
											}
										
										#send res
										my $resMsg="NOTICE ".$msgNick." :".$color.$textBefore.$response.$insertNick.$textAfter."\n";
										IRC::send_raw $resMsg;
										if($showSendOfResponse)
											{
												IRC::print("\0034++Script has send response(\#$numOfRes) to $msgNick++\003\n");
											}
										
										if($logging){logThis("RES: $numOfRes . RESPONSE send to $msgNick($hmSender)");}
									}
								
							}
					}
			}
		return 0;
	}


sub ro_command_handler
	{
		my $args = shift;
		chomp $args;
		$args=~ m/(.*?)\s\#(.*)/i;
		my $searchNick=$1;
		my $searchChannel="\#".$2;
		if(($searchNick eq '')||($searchChannel eq ''))
			{
				IRC::print("\0034++USE: /returnof nick #channel [optional: a message, wich will send to user if he returns]\003\n");
				return 1;
			}
		my $returnMsg=0;
		if($searchChannel=~ m/(.*?)\s(.*)/i)
			{
				$returnMsg=$2;
				$searchChannel=$1;
			}
		
		if($logging){ logThis("RO ($args)->$searchNick<>$searchChannel<>$returnMsg<");}
		
		my $actServer=IRC::get_info(3);
		
		if($logging){ logThis("RO act Server is: $actServer");}
		
		#DEBUG# IRC::print"1:$args->$searchNick<>$searchChannel<>$returnMsg<\n";
		my @userList=IRC::user_list($searchChannel,$actServer);
		
		if($logging){ logThis("RO got list from server,channel $searchChannel with $#userList users");}
		
		#DEBUG# IRC::print "2->@userList<-\n";
		my $userString="@userList";
		my $searchNickCV=$searchNick;
		$searchNickCV=~ s/([\|\[\]\^\-\_\\])/\\$1/g;
		$userString=~ m/$searchNickCV\s(.*?)\s/i;
		my $hostMask=$1;
		#DEBUG# IRC::print "3->$hostMask<-\n";
		if($hostMask eq '')
			{
				IRC::print("\0034++Didn\'t found $searchNick in channel $searchChannel !\003\n");
				
				if($logging){ logThis("RO didnt found $searchNick in $searchChannel");}
				return 1;
			} 
		$hm_HashReturn{$hostMask}=$returnMsg;
		my $text="+++sound(if turned on) will play if user $searchNick with hostmask $hostMask write a message";
		if($returnMsg)
			{
				$text.=" and the script will send \"$returnMsg\" to him"; 
			}
		IRC::print("\0034$text (CANCEL all with /reset)+++\003\n");
		
		if($logging){ logThis("RO added $searchNick($hostMask) (MSG=$returnMsg) to him");}
    
		return 1;
		
	}

sub ps_command_handler
  {
    my $arg = shift;
		if(($arg eq 'ON' )||($arg eq 'on'))
			{
				IRC::print("\0034++sound is turned ON\003 \n");
				$sound=1;
				%hm_HashRes=();
				%hm_HashQuery=();
			}
		else
			{
				if(($arg eq 'OFF' )||($arg eq 'off'))
					{
						IRC::print("\0034++sound is turned OFF\003 \n");
						$sound=0;
					}
				else
					{
						IRC::print("USE: /ps [on/off]\n");
						IRC::print("to turn sound on/off\n");
					}
			}
		return 1;
	}

sub ar_command_handler
	{
		my $arg = shift;
		if(($arg eq 'ON' )||($arg eq 'on'))
			{
				IRC::print("\0034++autoresponse is turned on\003 \n");
				$response=1;
				%hm_HashRes=();
				%hm_HashQuery=();
			}
		else
			{
				if(($arg eq 'OFF' )||($arg eq 'off'))
					{
						IRC::print("\0034++autoresponse is turned off\003 \n");
						$response=0;
					}
				else
					{
						IRC::print("USE: /as [on/off]\n");
						IRC::print("to turn autoresponse on/off\n");
					}
			}
		return 1;
	}

sub amsg_command_handler
  {
    my $text = shift;
		if($text)
			{
				my @actChannels = IRC::channel_list();
				my $myNick= IRC::get_info(1);
				my $numChannels = @actChannels;
				my @sendChan='';
				
				for(my $i=0;$i<$numChannels;$i+=3)
					{
						IRC::send_raw("PRIVMSG $actChannels[$i] :$text\n");
						IRC::print_with_channel("\0033<$myNick>\003 $text\n",$actChannels[$i],IRC::get_info(3));
						@sendChan=(@sendChan, $actChannels[$i]);
					}
				IRC::print("\0033->[send to channels:@sendChan]\003\n");
			}
		
		return 1;
	}

sub reset_command_handler
	{
		%hm_HashRes=();
		%hm_HashQuery=();
		%hm_HashReturn=();
		IRC::print("\0034+++script has reset+++\003\n");
		if($logging){logThis("RESET: reset all");}
		return 1;
	}

sub help_command_handler
	{
		IRC::print("\0035++geeAge's autoresponse script V0.3::\003 \n");
		IRC::print("\0033++USE: /response [on/off]\003\n");
		IRC::print("\0033++turns autoresponse on/off\003\n");
		IRC::print("\0033++USE: /sound [on/off]\n");
		IRC::print("\0033++turns sound and autoresponse on/off\003\n");
		IRC::print("\0033++USE: /amsg text\n");
		IRC::print("\0033++sends 'text' to all joined channels\003\n");
		IRC::print("\0033++USE: /returnof nick #channel [optional message to user if he returns]\n");
		IRC::print("\0033++plays a sound if user write something [and can send him a message]\003\n");
		IRC::print("\0033++USE: /reset\n");
		IRC::print("\0033++reset the sending of responses and first query-sound\003\n");
		
		#logging
		if($logging)
			{
				IRC::print("\0033++Logging in file $logfile\003\n");
				logThis("HELP call");
			}
		return 1;
}

sub logThis
  {
    my $text=$_[0];
    
    open(LOG, ">>$logfile");
    print LOG localtime(time()).": $text\n";
    close(LOG);
  }
